<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitHelper {

    public static function userCan($role) {
        $roles = CrossfitHelper::getUserRoles();
        return (in_array($role, $roles) || in_array('all', $roles));
    }

    public static function getUserRoles() {
        $roles = array();
        $groups = CrossfitHelper::getUserGroups();

        if ($groups) {
            foreach ($groups as $name) {
                switch ($name) {
                    case 'SUPER USERS':
                        $roles[] = 'all';
                        break;
                    case 'CONSULTAZIONE':
                        $roles[] = 'view';
                        $roles[] = 'print';
                        $roles[] = 'export';
                        break;
                }
            }
        }

        return $roles;
    }

    public static function isConsultazione() {
        foreach (self::getUserGroups() as $group) {
            if (strtoupper($group->title) == 'CROSSFIT - CONSULTAZIONE') {
                return true;
            }
        }
        return false;
    }

    public static function getPalestreConsultazione() {
        $groups = self::getUserGroups();
        foreach ($groups as $group) {
            if (strtoupper($group->title) == 'CROSSFIT - CONSULTAZIONE') {
                $idParent = $group->id;
            }
        }
        if ($idParent) {
            $palestre = array();
            foreach ($groups as $group) {
                if ($group->parent_id == $idParent) {
                    $palestre[] = strtolower($group->title);
                }
            }
            if ($palestre) {
                $db = JFactory::getDBO();
                $query = $db->getQuery(true);

                $query->select('*')->from('#__rseventspro_locations')->where('LOWER(name) IN ("' . implode('", "', $palestre) . '")');
                $db->setQuery($query);
                return $db->loadObjectList();
            }
        }
        return null;
    }

    public static function getUserGroups() {

        $user = JFactory::getUser();
        $groups = JAccess::getGroupsByUser($user->id);

        if ($groups) {

            $db = JFactory::getDBO();
            $query = $db->getQuery(true);

            $groupid_list = '(' . implode(',', $groups) . ')';

            $query->select('*')->from('#__usergroups')->where('id IN ' . $groupid_list);
            $db->setQuery($query);
            $rows = $db->loadObjectList();

            return $rows;
        }

        return null;
    }

    public static function getLocation() {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("id, name")->from("#__rseventspro_locations")->order("name");
        $db->setQuery($query);
        $objectList = $db->loadObjectList();

        $places = array();
        if ($objectList) {
            foreach ($objectList as $row) {
                $places[$row->id] = $row->name;
            }
        }

        return $places;
    }

    public static function getActualIdPalestra() {
        $session = JSession::getInstance();

        return $session->get("idPalestra");
    }

    public static function setActualIdPalestra($idPalestra) {
        $session = JSession::getInstance();
        $session->set("idPalestra", $idPalestra);
    }

    public static function calcoloRecuperi($idUser, $idUserJoomla) {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->clear()
                ->select("ab.idUser, ab.idSU, ab.dataInizio as dataInizioAbbonamento, ingressi")
                ->from("#__crossfit_v_scadenze_abbonamenti ab")
                ->innerJoin("#__crossfit_subscriptions s ON ab.idSubscription = s.idSubscription")
                ->where("ab.idUser = " . $db->quote($idUser))
                ->where("s.ad_ingressi = 1")
                ->where("NOW() BETWEEN ab.dataInizio AND ab.dataScadenzaAbbonamento");

        $array = $db->setQuery($query)->loadObject();

        if (!$array) {
            return null;
        }

        $risultato = array();

        $now = date("Y-m-d 23:59:59", strtotime("yesterday"));
        $risultato['questa-settimana']['settimana-numero'] = (int) date("W");

        // Capisco da che data partire
        if (strtotime($array->dataInizioAbbonamento) < strtotime("2017-04-03 00:00:00")) {
            $risultato['settimane-passate']['data-inizio'] = "2017-04-03 00:00:00";
        } elseif (date("w", strtotime($array->dataInizioAbbonamento)) == 0 || date("w", strtotime($array->dataInizioAbbonamento)) >= 4) {
            $risultato['settimane-passate']['data-inizio'] = date("Y-m-d 00:00:00", strtotime("next monday", strtotime($array->dataInizioAbbonamento)));
            $risultato['settimane-passate']['data-inizio-traslata'] = true;
        } else {
            $risultato['settimane-passate']['data-inizio'] = date("Y-m-d 00:00:00", strtotime($array->dataInizioAbbonamento));
        }
        $risultato['settimane-passate']['settimana-numero'] = (int) date("W", strtotime($risultato['settimane-passate']['data-inizio']));

        if ($risultato['questa-settimana']['settimana-numero'] == $risultato['settimane-passate']['settimana-numero']) {
            $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("next sunday"));
            $risultato['settimane-passate']['numero-settimane'] = 0;
        } else {
            if (date("w", time()) == 0) {
                $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("- 1 weeks"));
            } else {
                $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("last sunday"));
            }

            if (strtotime($risultato['settimane-passate']['data-fine']) > time()) {
                $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("last sunday"));
            }

            $start = new DateTime($risultato['settimane-passate']['data-inizio']);

            if (date("Y", strtotime($risultato['settimane-passate']['data-inizio'])) == date("Y", strtotime($risultato['settimane-passate']['data-fine']))) {
                $end = new DateTime($risultato['settimane-passate']['data-fine']);
                $interval = $end->diff($start);
                $risultato['settimane-passate']['numero-settimane'] = ceil($interval->days / 7);
            } elseif (date("Y", strtotime($risultato['settimane-passate']['data-inizio'])) < date("Y", strtotime($risultato['settimane-passate']['data-fine']))) {
                $end = new DateTime(date("Y", strtotime("last year")) . "-12-31 23:59:59");
                $interval = $end->diff($start);
                $risultato['settimane-passate']['numero-settimane'] = ceil($interval->days / 7);
                $start1 = new DateTime(date("Y") . "-01-01 00:00:00");
                $end1 = new DateTime($risultato['settimane-passate']['data-fine']);
                $interval1 = $end1->diff($start1);
                $risultato['settimane-passate']['numero-settimane'] += ceil($interval1->days / 7);
            } else {
                $risultato['settimane-passate']['numero-settimane'] = 0;
            }
        }

        $risultato['settimane-passate']['ingressi-potenziali'] = $risultato['settimane-passate']['numero-settimane'] * $array->ingressi;
        $risultato['settimane-passate']['ingressi-effettuati'] = 0;

        $query->clear();
        $query->select("U.idu, DATE(E.start) as date")
                ->from("#__rseventspro_users as U")
                ->innerJoin("#__rseventspro_events as E on E.id = U.ide")
                ->where("E.start BETWEEN '{$risultato['settimane-passate']['data-inizio']}' AND '{$risultato['settimane-passate']['data-fine']}'")
                ->where("U.idu = " . $idUserJoomla)
                ->group("U.idu, DATE(E.start)");

        if ($db->setQuery($query)->execute()) {
            $risultato['settimane-passate']['ingressi-effettuati'] = $db->getNumRows();
        } else {
            $risultato['settimane-passate']['ingressi-effettuati'] = 0;
        }
        $risultato['settimane-passate']['recuperi'] = $risultato['settimane-passate']['ingressi-potenziali'] - $risultato['settimane-passate']['ingressi-effettuati'];

        $query->clear();
        $query->select("*")->from("#__crossfit_subscriptions_sospensions")->where("closed = 1 AND startDate < endDate AND idSubscription = {$array->idSU}");

        $sospensioni = $db->setQuery($query)->loadObjectList();
        $weeksSospensione = 0;
        if ($sospensioni) {
            foreach ($sospensioni as $sospensione) {
                $diff = floor((strtotime($sospensione->endDate) - strtotime($sospensione->startDate)) / (60 * 60 * 24));
                $weeksSospensione += floor($diff / 6);
            }
        }
        if ($weeksSospensione) {
            $risultato['settimane-passate']['sospensioni']['settimane'] = $weeksSospensione;
            $risultato['settimane-passate']['sospensioni']['ingressi-da-stornare'] = $weeksSospensione * $array->ingressi;
            if ($risultato['settimane-passate']['recuperi']) {
                $risultato['settimane-passate']['recuperi'] -= $risultato['settimane-passate']['sospensioni']['ingressi-da-stornare'];
            }
        }

        $risultato['settimane-future']['data-inizio'] = date("Y-m-d 00:00:00", strtotime("next monday", strtotime($risultato['settimane-passate']['data-fine'])));
        $risultato['settimane-future']['ingressi-effettuati'] = 0;

        $query->clear();
        $query->select("U.idu, DATE(E.start) as date")
                ->from("#__rseventspro_users as U")
                ->innerJoin("#__rseventspro_events as E on E.id = U.ide")
                ->where("E.start > '{$risultato['settimane-passate']['data-fine']}'")
                ->where("U.idu = " . $idUserJoomla)
                ->group("U.idu, DATE(E.start)");

        $lists = $db->setQuery($query)->loadObjectList();
        if ($lists) {
            foreach ($lists as $date) {
                $arraySETT[date("W", strtotime($date->date))] += 1;
                $risultato['settimane-future']['ingressi-effettuati'] += 1;
            }
        }
        if ($arraySETT) {
            foreach ($arraySETT as $sett) {
                $risultato['settimane-future']['ingressi-effettuabili'] += $array->ingressi;
            }
        }
        if ($risultato['settimane-future']['ingressi-effettuati'] > $risultato['settimane-future']['ingressi-effettuabili']) {
            $risultato['settimane-future']['ingressi-recuperati'] = $risultato['settimane-future']['ingressi-effettuati'] - $risultato['settimane-future']['ingressi-effettuabili'];
        } else {
            $risultato['settimane-future']['ingressi-recuperati'] = 0;
        }
        $risultato['settimane-future']['ingressi-recuperabili'] = $risultato['settimane-passate']['recuperi'] - $risultato['settimane-future']['ingressi-recuperati'];


        if (date("N", strtotime($now)) != 1) {
            $risultato['questa-settimana']['data-inizio'] = strtotime("last monday", strtotime($now));
        } else {
            $risultato['questa-settimana']['data-inizio'] = strtotime($now);
        }
        if ($risultato['questa-settimana']['data-inizio'] <= strtotime($array->dataInizioAbbonamento)) {
            $risultato['questa-settimana']['data-inizio'] = strtotime($array->dataInizioAbbonamento);
        }
        $risultato['questa-settimana']['data-inizio'] = date("Y-m-d 00:00:00", $risultato['questa-settimana']['data-inizio']);
        $risultato['questa-settimana']['data-fine'] = date("Y-m-d 23:59:59", strtotime("next sunday", strtotime($risultato['questa-settimana']['data-inizio'])));

        $query->clear();
        $query->select("U.idu, DATE(E.start) as date")
                ->from("#__rseventspro_users as U")
                ->innerJoin("#__rseventspro_events as E on E.id = U.ide")
                ->where("E.start BETWEEN '{$risultato['questa-settimana']['data-inizio']}' AND '{$risultato['questa-settimana']['data-fine']}'")
                ->where("U.idu = " . $idUserJoomla)
                ->group("U.idu, DATE(E.start)");

        $db->setQuery($query)->execute();
        $risultato['questa-settimana']['ingressi-effettuati'] = $db->getNumRows();
        $risultato['questa-settimana']['ingressi-disponibili'] = $array->ingressi - $risultato['questa-settimana']['ingressi-effettuati'];

        return $risultato['settimane-future']['ingressi-recuperabili'] ? $risultato['settimane-future']['ingressi-recuperabili'] : "-";
    }

    static function getDataScadenzaIscrizione($idUser) {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("dataScadenza")->from("#__crossfit_v_scadenze_iscrizioni")->where("idUser = " . (int) $idUser);
        $query->order("dataScadenza DESC");

        return $db->setQuery($query, 0, 1)->loadResult();
    }

    static function getDataScadenzaAbbonamento($idUser) {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("dataScadenzaAbbonamento")
                ->from("#__crossfit_v_scadenze_abbonamenti")
                ->where("idUser = " . (int) $idUser)
                ->order("dataScadenzaAbbonamento DESC");

        return $db->setQuery($query, 0, 1)->loadResult();
    }

    static function isSospeso($idUser) {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("sospeso")->from("#__crossfit_v_scadenze_abbonamenti")->where("idUser = " . (int) $idUser);
        $query->order("dataScadenzaAbbonamento DESC");

        return $db->setQuery($query, 0, 1)->loadResult();
    }

}
