<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.form.formfield');

class JFormFieldSubscriptionTypeFilter extends JFormField {

    protected $type = 'SubscriptionTypeFilter';

    public function getInput() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select("idSubscription, nome, prezzo, mesi, adIngressiTotali")
                ->from($db->quoteName("#__crossfit_subscriptions"))
                ->where("published = 1")
                ->order("nome ASC");

        $db->setQuery($query);
        $resultsTypes = $db->loadObjectList();
        $query->clear();

        $query->select("DISTINCT mesi")
                ->from($db->quoteName("#__crossfit_subscriptions"))
                ->where("published = 1")
                ->where("mesi > 0")
                ->order("mesi ASC");
        $db->setQuery($query);
        $resultsMONTHS = $db->loadObjectList();
        $query->clear();

        $arrayMesi = array(
            1 => 'Mensile',
            2 => 'Bimestrale',
            3 => 'Trimestrale',
            4 => 'Quadrimestrale',
            6 => 'Semestrale',
            12 => 'Annuale',
        );

        ob_start();
        ?>
        <select id="<?php echo $this->id ?>" name="<?php echo $this->name ?>" class="<?php echo ($this->value ? "active" : null) ?>" <?php echo $this->onchange ? "onchange='{$this->onchange}'" : null ?>>
            <option <?php echo (!$this->value ? "selected='selected'" : "") ?> value=''> - Tipologia di abbonamento - </option>
            <?php
            if ($resultsMONTHS) {
                foreach ($resultsMONTHS as $v) {
                    ?>
                    <option value='MTH-<?php echo $v->mesi ?>' <?php echo ($this->value == "MTH-" . $v->mesi ? "selected='selected'" : "") ?>>Durata: <?php echo $arrayMesi[$v->mesi] ?></option>
                    <?php
                }
            }
            if ($resultsTypes) {
                foreach ($resultsTypes as $v) {
                    ?>
                    <option value='<?php echo $v->idSubscription ?>' <?php echo ($this->value == $v->idSubscription ? "selected='selected'" : "") ?>><?php echo $v->nome ?></option>
                    <?php
                }
            }
            ?>
            <option value='CUSTOM-01' <?php echo ($this->value == "CUSTOM-01" ? "selected='selected'" : "") ?>>Custom: ad ingressi totali</option>
        </select>
        <?php
        return ob_get_clean();
    }

}
?>