<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitModelMembership extends JModelList {

    var $insertedId = null;

    public function __construct($config = array()) {
        if (empty($config['filter_fields'])) {
            $config['filter_fields'] = array(
                'idMembership',
                'idUser',
                'prezzo',
                'dataInizio',
                'dataScadenza',
                'pagato',
                'durata'
            );
        }

        parent::__construct($config);
    }

    public function getItem() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('*')->from($db->quoteName('#__crossfit_memberships'))->where('idMembership = ' . (int) JRequest::getVar('idMembership'));

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getForm($data = array(), $loadData = true) {
        $form = $this->loadForm('com_crossfit.user.membership', 'user.membership', array('control' => 'jformMembership', 'load_data' => $loadData));

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    public function delete($id = null) {
        if (!$id)
            return;

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->delete('#__crossfit_memberships')->where('idMembership = ' . $query->quote($id));

        $db->setQuery($query);

        return $db->execute();
    }

    public function save() {
        $db = JFactory::getDbo();
        $post = JRequest::get('post');
        $post = $post['jformMembership'];

        $post['dataInizioM'] = explode("/", $post['dataInizioM']);
        $post['dataInizioM'] = "{$post['dataInizioM'][2]}-{$post['dataInizioM'][1]}-{$post['dataInizioM'][0]}";

        $data = new stdClass;
        $data->idMembership = $post['idMembership'];
        $data->dataInizio = $post['dataInizioM'];
        $data->costo = $post['costo'];
        $data->pagato = $post['pagatoM'];

        return $db->updateObject('#__crossfit_memberships', $data, idMembership, true);
    }

    public function setpayed() {
        $db = JFactory::getDbo();
        $idUser = JRequest::getVar('idUser');
        $idMembership = JRequest::getVar('idMembership');

        if (!$idUser || !$idMembership)
            return false;

        $query = $db->getQuery(true);

        $query->update($db->qn('#__crossfit_memberships'))
                ->set('pagato = ' . $db->quote(1))
                ->where('idUser = ' . $db->quote($idUser))
                ->where('idMembership = ' . $db->quote($idMembership));

        $db->setQuery($query);
        return $db->execute();
    }

}
