<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitModelUser extends JModelAdmin {

    var $insertedId = null;

    public function getTable($type = 'User', $prefix = 'CrossfitTable', $config = array()) {
        return JTable::getInstance($type, $prefix, $config);
    }

    public function getForm($data = array(), $loadData = true) {
        $form = $this->loadForm('com_crossfit.user', 'user', array(
            'control' => 'jformUser',
            'load_data' => $loadData));

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    public function getPropertiesForm($data = array(), $loadData = false) {
        $form = $this->loadForm('com_crossfit.user.properties', 'user.properties', array(
            'control' => 'jformUser',
            'load_data' => $loadData));

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    public function getSubscriptionForm($data = array(), $loadData = false) {
        $form = $this->loadForm('com_crossfit.user.subscription', 'user.subscription', array(
            'control' => 'jformSubscription',
            'load_data' => $loadData));

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    public function getMembershipForm($data = array(), $loadData = false) {
        $form = $this->loadForm('com_crossfit.user.membership', 'user.membership', array(
            'control' => 'jformMembership',
            'load_data' => $loadData));

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    protected function loadFormData() {
        $data = JFactory::getApplication()->getUserState(
                'com_crossfit.edit.user.data', array()
        );

        if (empty($data)) {
            $data = $this->getItem();
        }

        return $data;
    }

    public function getItem($pk = NULL) {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('a.*, b.username, b.email')
                ->from($db->quoteName('#__crossfit_users', 'a'))
                ->innerJoin($db->quoteName('#__users', 'b') . " ON b.id = a.idUserJoomla")
                ->where("idUser = " . $query->quote((int) JRequest::getVar('idUser')));

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getSubscriptions() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query
                ->select('a.idUser, a.idSubscription, b.nome, a.prezzo, dataInizio as dataInizioS, dataScadenzaReale, a.idSU,
                        DATE_ADD(DATE_ADD(DATE_ADD(a.dataInizio, INTERVAL b.mesi MONTH), INTERVAL a.giorniAggiuntivi DAY), INTERVAL a.giorniSospensione DAY) as dataScadenzaS, sospeso, giorniSospensione, pagato as pagatoS, note')
                ->from($db->quoteName('#__crossfit_subscriptions_users', 'a'))
                ->join('INNER', $db->quoteName('#__crossfit_subscriptions', 'b') . ' ON (' . $db->quoteName('a.idSubscription') . ' = ' . $db->quoteName('b.idSubscription') . ')')
                ->where("idUser = " . $query->quote((int) JRequest::getVar('idUser')))
                ->order("dataScadenzaS DESC");

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getMemberships() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query
                ->select('idMembership, idUser, costo, dataInizio as dataInizioM, DATE_ADD( dataInizio, INTERVAL durata YEAR ) as dataScadenzaM, pagato as pagatoM, durata')
                ->from($db->quoteName('#__crossfit_memberships'))
                ->where("idUser = " . $query->quote((int) JRequest::getVar('idUser')))
                ->order("dataScadenzaM DESC");

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getMembership() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('idMembership, idUser, costo, dataInizio as dataInizioM, pagato as pagatoM, durata')
                ->from($db->quoteName('#__crossfit_memberships'))
                ->where('idMembership = ' . (int) JRequest::getVar('idMembership'));

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getSubscription() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('idUser, idSubscription, prezzo, dataInizio as dataInizioS, dataScadenzaReale, a.dataAcconto, idSU, giorniAggiuntivi, sospeso, allenamentoAggiuntivo, giorniSospensione, pagato as pagatoS, note')
                ->from($db->quoteName('#__crossfit_subscriptions_users', 'a'))
                ->where("idSU = " . $query->quote((int) JRequest::getVar('idSU')));

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function save($data = null) {
        $db = JFactory::getDbo();
        $post = JRequest::get('post');
        $post = $post['jformUser'];

        foreach ($post as $k => $v) {
            $post[$k] = trim($v);
        }

        $post['dataNascita'] = explode("/", $post['dataNascita']);
        $post['dataNascita'] = "{$post['dataNascita'][2]}-{$post['dataNascita'][1]}-{$post['dataNascita'][0]}";

        if ($post['dataCertificato']) {
            $post['dataCertificato'] = explode("/", $post['dataCertificato']);
            $post['dataCertificato'] = "{$post['dataCertificato'][2]}-{$post['dataCertificato'][1]}-{$post['dataCertificato'][0]}";
        } else {
            $post['dataCertificato'] = null;
        }

        $data = new stdClass;

        $data->nome = ucwords(strtolower($post['nome']));
        $data->cognome = ucwords(strtolower($post['cognome']));
        $data->email = strtolower($post['email']);
        $data->codiceFiscale = strtoupper($post['codiceFiscale']);
        $data->telefono = str_replace(" ", "", $post['telefono']);
        $data->foto = $post['foto'];
        $data->dataNascita = $post['dataNascita'];
        $data->indirizzo = $post['indirizzo'];
        $data->citta = $post['citta'];
        $data->provincia = $post['provincia'];
        $data->dataCertificato = $post['dataCertificato'];
        $data->note = $post['note'];
        $data->cittaNascita = $post['cittaNascita'];
        $data->categoria = $post['categoria'];
        $data->anzianita = $post['anzianita'];
        $data->idPalestra = $post['idPalestra'];

        if ($post['idUser']) {
            $data->idUser = $post['idUser'];

            $this->updateJoomlaUserData($data, $post['idUserJoomla']);

            $this->saveMembership($post['idUser']);
            $this->saveSubscription($post['idUser']);

            return $db->updateObject('#__crossfit_users', $data, idUser, true);
        } else {

            $data->username = $post['username'];
            $data->idUserJoomla = $this->addNewJoomlaUser($data);

            $return = $db->insertObject('#__crossfit_users', $data, idUser, true);
            $this->insertedId = $db->insertid();

            $this->saveMembership($this->insertedId);
            $this->saveSubscription($this->insertedId);

            return $return;
        }
    }

    public function saveMembership($id = null) {
        if (!$id) {
            return null;
        }

        $db = JFactory::getDbo();
        $post = JRequest::get('post');
        $post = $post['jformMembership'];

        if (!$post['dataInizioM']) {
            return null;
        }
        $post['dataInizioM'] = explode("/", $post['dataInizioM']);
        $post['dataInizioM'] = "{$post['dataInizioM'][2]}-{$post['dataInizioM'][1]}-{$post['dataInizioM'][0]}";

        $data = new stdClass;

        $data->idUser = $id;
        $data->dataInizio = $post['dataInizioM'];
        $data->costo = $post['costo'];
        $data->pagato = $post['pagatoM'];
        $data->durata = $post['durata'];

        if ($post['idMembership']) {
            $data->idMembership = $post['idMembership'];
            return $db->updateObject('#__crossfit_memberships', $data, idMembership, true);
        } else {
            return $db->insertObject('#__crossfit_memberships', $data, idMembership, true);
        }
    }

    public function saveSubscription($id = null) {
        if (!$id)
            return null;

        $db = JFactory::getDbo();
        $post = JRequest::get('post');
        $post = $post['jformSubscription'];

        if (!$post['idSubscription'])
            return null;

        if (trim($post['dataInizioS']) != "") {
            $post['dataInizioS'] = explode("/", $post['dataInizioS']);
            $post['dataInizioS'] = "{$post['dataInizioS'][2]}-{$post['dataInizioS'][1]}-{$post['dataInizioS'][0]}";
        } else {
            $post['dataInizioS'] = null;
        }
        if (trim($post['dataScadenzaReale']) != "") {
            $post['dataScadenzaReale'] = explode("/", $post['dataScadenzaReale']);
            $post['dataScadenzaReale'] = "{$post['dataScadenzaReale'][2]}-{$post['dataScadenzaReale'][1]}-{$post['dataScadenzaReale'][0]}";
        } else {
            $post['dataScadenzaReale'] = null;
        }
        if (trim($post['dataAcconto']) != "") {
            $post['dataAcconto'] = explode("/", $post['dataAcconto']);
            $post['dataAcconto'] = "{$post['dataAcconto'][2]}-{$post['dataAcconto'][1]}-{$post['dataAcconto'][0]}";
        } else {
            $post['dataAcconto'] = null;
        }

        $data = new stdClass;

        $data->idUser = $id;
        $data->idSubscription = $post['idSubscription'];
        $data->dataInizio = $post['dataInizioS'];
        $data->dataScadenzaReale = $post['dataScadenzaReale'];
        $data->dataAcconto = $post['dataAcconto'];
        $data->giorniAggiuntivi = $post['giorniAggiuntivi'];
        $data->prezzo = $post['prezzo'];
        $data->pagato = $post['pagatoS'];
        $data->sospeso = $post['sospeso'];
        $data->allenamentoAggiuntivo = $post['allenamentoAggiuntivo'];
        $data->giorniSospensione = $post['giorniSospensione'];
        $data->note = $post['note'];

        if ($post['idSU']) {
            $data->idSU = $post['idSU'];

            $oldSospeso = $db->setQuery("SELECT sospeso FROM #__crossfit_subscriptions_users WHERE idSU = {$post['idSU']}")->loadResult();

            if ($oldSospeso != $post['sospeso'] && !$oldSospeso) {
                $sospdata = new stdClass();
                $sospdata->idSubscription = $post['idSU'];
                if (date("w") == 1) {
                    $sospdata->startDate = date("Y-m-d 00:00:00");
                } else {
                    $sospdata->startDate = date("Y-m-d 00:00:00", strtotime("last monday"));
                }
                $sospdata->endDate = '0000-00-00 00:00:00';
                $db->insertObject('#__crossfit_subscriptions_sospensions', $sospdata, 'idSospension', true);
            } elseif ($oldSospeso != $post['sospeso'] && $oldSospeso) {
                $idSosp = $db->setQuery("SELECT idSospension FROM #__crossfit_subscriptions_sospensions WHERE idSubscription = {$post['idSU']} AND closed = 0 ORDER by startDate DESC LIMIT 0,1")->loadResult();
                if ($idSosp) {
                    if (date("w") == 0) {
                        $endDate = date("Y-m-d 23:59:59");
                    } else {
                        $endDate = date("Y-m-d 23:59:59", strtotime("last sunday"));
                    }
                    $sosquery = "UPDATE #__crossfit_subscriptions_sospensions SET endDate = '" . $endDate . "', closed = 1 WHERE idSospension = {$idSosp}";
                } else {
                    if (date("w") == 1) {
                        $startDate = date("Y-m-d 00:00:00");
                    } else {
                        $startDate = date("Y-m-d 00:00:00", strtotime("last monday"));
                    }
                    if (date("w") == 0) {
                        $endDate = date("Y-m-d 23:59:59");
                    } else {
                        $endDate = date("Y-m-d 23:59:59", strtotime("next sunday"));
                    }
                    $sosquery = "INSERT INTO #__crossfit_subscriptions_sospensions (idSubscription, startDate, endDate, closed) VALUES ({$post['idSU']}, '{$startDate}', '{$endDate}', 1)";
                }
                $db->setQuery($sosquery)->execute();
            }

            $days = $db->setQuery("SELECT SUM(DATEDIFF(endDate, startDate)) FROM #__crossfit_subscriptions_sospensions WHERE endDate > startDate AND idSubscription = {$post['idSU']}")->loadResult();
            $data->giorniSospensione = $days;

            $db->updateObject('#__crossfit_subscriptions_users', $data, idSU, true);
        } else {
            $db->insertObject('#__crossfit_subscriptions_users', $data, idSU, true);

            if ($post['sospeso']) {
                $sospdata = new stdClass();
                $sospdata->idSubscription = $db->insertid();
                $sospdata->startDate = date("Y-m-d 00:00:00");
                $sospdata->endDate = '0000-00-00 00:00:00';
                $db->insertObject('#__crossfit_subscriptions_sospensions', $sospdata, 'idSospension', true);
            }
        }
        return true;
    }

    private function addNewJoomlaUser($data, $username) {

        $userData = array(
            "name" => $data->nome . " " . $data->cognome,
            "username" => $data->username,
            "email" => $data->email,
            "block" => 0,
            "groups" => array("10")
        );

        jimport('joomla.user.helper');
        $user = new JUser;
        if (!$user->bind($userData)) {
            throw new Exception("Impossibile caricare i dati dell'utente. Error: " . $user->getError());
        }
        if (!$user->save()) {
            throw new Exception("Impossibile salvare il nuovo utente. Error: " . $user->getError());
        }

        return $user->id;
    }

    public function updateJoomlaUserData($data, $id) {
        $userData = array(
            "name" => $data->nome . " " . $data->cognome,
            "email" => $data->email
        );

        jimport('joomla.user.helper');
        $user = JFactory::getUser($id);

        if (!$user->bind($userData)) {
            throw new Exception("Impossibile caricare i dati dell'utente. Error: " . $user->getError());
        }
        if (!$user->save()) {
            throw new Exception("Impossibile salvare il nuovo utente. Error: " . $user->getError());
        }
        return true;
    }

    public function getSospensions() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select("*")->from("#__crossfit_subscriptions_sospensions")->where("idSubscription = " . JRequest::getVar("idSU"))->order("startDate DESC, idSospension DESC");
        $db->setQuery($query);

        return $db->loadObjectList();
    }

}
