<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitViewSubscriptions extends JViewLegacy {

    function display($tpl = null) {
        if (count($errors = $this->get('Errors'))) {
            JError::raiseError(500, implode('<br />', $errors));
            return false;
        }

        switch (JFactory::getApplication()->input->getCmd('layout', 'default')) {
            case 'edit':
                $this->form = $this->get('Form');
                $this->item = $this->get('Item');

                $this->form->bind($this->item);

                $this->addToolBarEdit();
                break;
            case 'new':
                $this->form = $this->get('Form');

                $this->addToolBarEdit();
                break;
            case 'default':
            default:
                $this->items = $this->get('Items');
                $this->pagination = $this->get('Pagination');
                $this->state = $this->get('State');
                $this->filterForm = $this->get('FilterForm');
                $this->activeFilters = $this->get('ActiveFilters');
                $this->addToolBar();
                break;
        }

        parent::display($tpl);
    }

    protected function addToolBarEdit() {
        if (JRequest::getVar('id')) {
            $title = "Modifica dettagli abbonamento # " . JRequest::getVar('id');
        } else {
            $title = "Nuovo abbonamento";
        }

        $input = JFactory::getApplication()->input;
        $input->set('hidemainmenu', true);

        JToolBarHelper::title($title, 'folder');

        if (JFactory::getUser()->authorise('crossfit.edit', 'com_crossfit')) {
            JToolBarHelper::apply('subscriptions.apply');
            JToolBarHelper::save('subscriptions.save');
            JToolbarHelper::save2new('subscriptions.save2new');
        }
        JToolBarHelper::cancel('subscriptions.cancel');
    }

    protected function addToolBar() {
        $title = "Tipi di abbonamenti";

        if ($this->pagination->total) {
            $title .= " (" . $this->pagination->total . ")";
        }

        JToolBarHelper::title($title, 'folder');
        if (JFactory::getUser()->authorise('crossfit.edit', 'com_crossfit')) {
            JToolBarHelper::deleteList('Vuoi eliminare gli elementi selezionati?', 'subscriptions.delete');
            JToolBarHelper::editList('subscriptions.edit');
            JToolBarHelper::addNew('subscriptions.add');
        }
    }

}
